/**
 * Safely assert whether the given value is an ArrayBuffer.
 *
 * In some execution environments ArrayBuffer is not defined.
 */
export declare function isArrayBuffer(value: unknown): value is ArrayBuffer;
/**
 * Safely assert whether the given value is a Blob.
 *
 * In some execution environments Blob is not defined.
 */
export declare function isBlob(value: unknown): value is Blob;
/**
 * Safely assert whether the given value is a FormData instance.
 *
 * In some execution environments FormData is not defined.
 */
export declare function isFormData(value: unknown): value is FormData;
/**
 * Safely assert whether the given value is a URLSearchParams instance.
 *
 * In some execution environments URLSearchParams is not defined.
 */
export declare function isUrlSearchParams(value: unknown): value is URLSearchParams;
/**
 * Safely assert whether the given value is a number.
 */
export declare function isNumber(value: unknown): value is number;
/**
 * Safely assert whether the given value is a boolean.
 */
export declare function isBoolean(value: unknown): value is number;
/**
 * Safely assert whether the given value is an object.
 */
export declare function isObject(value: unknown): value is number;
